function [resultsLmm, errors, alphasLmm, goodswLmm, execTime, warningM, goodswM] = DCheuristic5(L, m, T, testcase)
execTime=0;
lastwarn('OK');
warningM{1,1} = lastwarn;
errors(1,1) = NaN;
tic;
ell=0;
MPopt = mpoption('OPF_ALG', 0, 'VERBOSE', 0, 'OUT_ALL', 0, 'ENFORCE_Q_LIMS', 1);
% date:
tod = date;
% load the base case testcase)
basec = loadcase(testcase);
n=size(basec.branch,1);
% initialize
bPflow = NaN(n,2);
bPloss = NaN(n,2);
bQflow = NaN(n,2);
bQloss = NaN(n,2);
bbusfrom = NaN(n,2);
bbusto = NaN(n,2);
bpiPfrom = NaN(n,2);
bpiPto = NaN(n,2);
bpiQfrom = NaN(n,2);
bpiQto = NaN(n,2);
balphas = NaN(n,2);
bgoodsw = NaN(n,3);
Pflow = NaN(L,2);
Ploss = NaN(L,2);
Qflow = NaN(L,2);
Qloss = NaN(L,2);
busfrom = NaN(L,2);
busto = NaN(L,2);
piPfrom = NaN(L,2);
piPto = NaN(L,2);
piQfrom = NaN(L,2);
piQto = NaN(L,2);
alphas = NaN(L,2);
goodsw = NaN(T,6);
goodswM{1,:} = goodsw(:,:);
%
errors(1,1) = NaN;
% outer LOOP of the heuristic algorithm
for e1 = 1:L
    lastwarn('OK');
    bresults=rundcopf(basec,MPopt); %DC
    % base case must have an admissible solution
    if (bresults.success == 0)
        if e1 == 1
            indexmm = 1;
            goodsw = NaN(T,6);
            balphas = NaN(n,2);
            goodswM{indexmm,:} = goodsw(:,:);
            resultsLmm{indexmm,:} = bresults(1,:);
            alphasLmm(indexmm,:) = balphas(1,:);
            goodswLmm(indexmm,:) = goodsw(1,:);
            execTime = toc;
            msgbox('The base case does not have admissible solutions under the current parameter settings. End of program')
            return;
        else
            ell = ell + 1;
            indexmm = ell;
            goodsw = NaN(T,6);
            balphas = NaN(n,2);
            goodswM{indexmm,:} = goodsw(:,:);
            resultsLmm{indexmm,:} = results{1,:};
            alphasLmm(indexmm,:) = balphas(1,:);
            goodswLmm(indexmm,:) = goodsw(1,:);
            execTime = toc;
            msgbox('The base case does not have admissible solutions under the current parameter settings. End of program')
            return;
        end
    end
    baseobjfunv = bresults.f;
    % define the alphas for the base case
    for i=1:n
        bPflow(i,:) = [i,bresults.branch(i,14)];
        bPloss(i,:) = [i,bresults.branch(i,14)+ bresults.branch(i,16)];
        bQflow(i,:) = [i,bresults.branch(i,15)];
        bQloss(i,:) = [i,bresults.branch(i,15)+ bresults.branch(i,17)];
        bbusfrom(i,:) = [i,bresults.branch(i,1)];
        bbusto(i,:) = [i,bresults.branch(i,2)];
        bpiPfrom(i,:) = [i,bresults.bus(bbusfrom(i,2),14)];
        bpiPto(i,:) = [i,bresults.bus(bbusto(i,2),14)];
        bpiQfrom(i,:) = [i,bresults.bus(bbusfrom(i,2),15)];
        bpiQto(i,:) = [i,bresults.bus(bbusto(i,2),15)];
        balphas(i,:) = [i,((bpiPto(i,2)-bpiPfrom(i,2)).*bPflow(i,2))]; %DC calculation of alpha
    end
    % define a ranking index associated with the ordered base alphas (lowest to highest)
    alphassort = sortrows(balphas,2);
    alphasT=alphassort(1:T,:);
    indexT=abs(alphasT(:,1));
    cases = cell(T,1);
    % copy the structure (and the data) of the base case basec in each cases(i,1)
    cases(:) = {basec};
    % create the instances by switching off lines
    for i=1:T
        cases{i}.branch(indexT(i),11) = 0;
    end
    % Allocate memory
    results=cell(T,1);
    mm = 0;
    goodsw = NaN(T,6);
    %
    % inner LOOP of the heuristic algorithm
    for i=1:T
        lastwarn('OK');
        %
        % call Matpower and solve the OPF for the i-th instance with the options MPopt
        resultstmp=rundcopf(cases{i,1},MPopt); %DC
        warningM{e1,i} = lastwarn;
        if (resultstmp.success == 0)
            errors(e1,i) = i;
            warningM{e1,i} = 'error - NOT feasible';
        else
            results{i,1}=resultstmp;
            currentobjfunv = results{i,1}.f;
            deltaobjfunv = currentobjfunv - baseobjfunv;
            errors(e1,i) = 0;
            % check for the presence of savings
            if deltaobjfunv < 0
                mm=mm+1;
                % save the results associated with the switching action that produce savings (good switching)
                goodsw(i,:) = [i,deltaobjfunv,deltaobjfunv/baseobjfunv, bresults.branch(indexT(i),1), bresults.branch(indexT(i),2), alphasT(i,2)];
                if mm==m;
                    break;
                end
            end
        end
        %
        % end of the inner LOOP of the heuristic algorithm
    end
    % if the candidate set is void
    if mm==0
        if e1 == 1
            goodsw = NaN(T,6);
            resultsLmm{1,:} = results{1,:};
            goodswLmm(1,:) = goodsw(1,:);
            goodswM{e1,:} = goodsw(:,:);
            alphasLmm(1,:) = balphas(1,:);
            msgbox('There are not convenient switching actions under the current parameter settings (L). End of program')
            execTime = toc;
            % exit from the program
            return;
        else
            ell = ell + 1;
            indexmm = ell;
            goodsw = NaN(T,6);
            balphas = NaN(n,2);
            goodswM{indexmm,:} = goodsw(:,:);
            resultsLmm{indexmm,:} = results{1,:};
            alphasLmm(indexmm,:) = balphas(1,:);
            goodswLmm(indexmm,:) = goodsw(1,:);
            msgbox('There are not (other) convenient switching actions under the current parameter settings (mm, L and T). End of program')
            execTime = toc;
            % exit from the program
            return;
        end
        % otherwise
    else
        % update the parameters and continue the LOOP
        ell = ell + 1;
        indexmm = ell;
        goodswsort = sortrows(goodsw,2);
        goodswM{indexmm,:} = goodsw(:,:);
        indexg1 = goodswsort(1,1);
        resultsLmm{indexmm,:} = results{indexg1,:};
        indexa = indexT(indexg1);
        alphasLmm(indexmm,:) = balphas(indexa,:);
        goodswLmm(indexmm,:) = goodswsort(1,:);
        basec.branch(indexa,11) = 0;
        if ell == L
            resultsLmm{indexmm,:} = results{indexg1,:};
            alphasLmm(indexmm,:) = balphas(indexa,:);
            goodswLmm(indexmm,:) = goodswsort(1,:);
            goodswM{indexmm,:} = goodsw(:,:);
            execTime = toc;
            % exit from the program
            return;
        end
    end
    %
    % end of the outer LOOP of the heuristic algorithm
end
%
% function end
end