clear

format long
format compact
define_constants;

%Input parameters:

rho=0.95;
mu=0;

%POLISH CASE PARAMETERS
%casename='case2736_updated';
%branch_cut=[202,52,100,195,356,238,246,47,309,2619,85,98,91,46,283,154,153,155,2433,161];
%n=2736;
%tau and sigma for increasing loads (12 stages):
%tau=[0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02];
%sigma=[0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02];
%tau and sigma for decreasing loads (8 stages):
%tau=[-0.02, -0.02, -0.02, -0.02, -0.02, -0.02, -0.02, -0.02];
%sigma=[0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02];

%case118 CASE PARAMETERS
%casename='nesta_case118_scaled';
%n=118;
%branch_cut=[60, 146, 145, 80, 82, 76, 73, 143, 75, 92, 91, 111, 31];
%tau and sigma from 06:00 and the next 24 hours (based on GB demandstatistics)
%tau=[0.22, 0.15, 0.03, 0.03, 0,0,0,-0.01, 0, 0.02, 0.07, 0.04, -0.01, -0.05, -0.07, -0.10, -0.10, -0.10, -0.01, -0.03, -0.02, -0.04, -0.02, -0.06];
%sigma=[0.04, 0.03, 0.02, 0.02, 0.02, 0.01, 0.01, 0.01, 0.01, 0.01, 0.02, 0.03, 0.02, 0.01, 0.01, 0.01, 0.01, 0.01, 0.04,  0.01, 0.01, 0.01, 0.01, 0.02];
%tau and sigma from 17:00 and the next 24 hours (based on GB demandstatistics)
%tau=[0.04, -0.01, -0.05, -0.07, -0.10, -0.10, -0.10, -0.01, -0.03, -0.02, -0.04, -0.02, -0.06, 0.22, 0.15, 0.03, 0.03, 0,0,0,-0.01, 0, 0.02, 0.07];
%sigma=[0.03, 0.02, 0.01, 0.01, 0.01, 0.01, 0.01, 0.04,  0.01, 0.01, 0.01, 0.01, 0.02, 0.04, 0.03, 0.02, 0.02, 0.02, 0.01, 0.01, 0.01, 0.01, 0.01, 0.02];

%GB CASE PARAMETERS
%casename='GBlinearThermal_scaled');
%branch_cut=[1425,370,1417,375,747,780,1416,793,2523,2641,1289,1210,781,1271,1148,1149,339,321,344,382];
%tau and sigma for increasing loads (5 stages):
%tau=[0.02, 0.02, 0.02, 0.02, 0.02];
%sigma=[0.02, 0.02, 0.02, 0.02, 0.02];
%tau and sigma for decreasing loads (8 stages):
%tau=[-0.02, -0.02, -0.02, -0.02, -0.02, -0.02, -0.02, -0.02];
%sigma=[0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02];

 mpc=loadcase(casename);
 A=size(branch_cut);
 S=size(tau);

for j=1:100;
 
for i=1:S(2);

   
for ii=1:A(2);
    %Turns on branch by branch
    mpc.branch(branch_cut(ii), BR_STATUS)=1;
end

    newdemand=(1+tau(i))* exp(-mu- sigma(i)^2/ 2)* exp(mvnrnd(mu* ones(1,n), sigma(i)^2* (rho* ones(n)+ (1-rho)*eye(n))));
    B=reshape(newdemand, n, 1);
    mpc.bus(:, PD)=mpc.bus(:, PD).*B;
    mpopt=mpoption('verbose',0,'out.all',0);
    obval_without=runopf(mpc,mpopt);
    res_without(i,j)=obval_without.f;
    conv_without(i,j)=obval_without.success;



for ii=1:A(2);
    %Turns off branch by branch
    mpc.branch(branch_cut(ii), BR_STATUS)=0;
end



obval_with=runopf(mpc,mpopt);
res_with(i,j)=obval_with.f;
conv_with(i,j)=obval_with.success;

end
mpc=loadcase(casename);
end


for i=1:S(2);
    disp(' ')
    X = ['STAGE ',i];
    disp(' ');
  
    for j=1:100;
        if conv_with(i,j)+conv_without(i,j) < 2;
            disp('did not converge');
        else
   
        diff(i,j)=(res_with(i,j)-res_without(i,j))/res_without(i,j);
        disp(diff(i,j));
        end
   
    end
end













